=== debian/changelog ===
superlu-dist (8.1.2+dfsg1-1) unstable; urgency=medium

  * New upstream release.

 -- Drew Parsons <dparsons@debian.org>  Fri, 18 Nov 2022 13:45:17 +0100
