=== debian/watch ===
version=4
opts="dversionmangle=s/\+dfsg\d*$//,repacksuffix=+dfsg1, \
 filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%superlu_dist-$1.tar.gz%" \
 https://github.com/xiaoyeli/superlu_dist/tags \
 (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
